// eslint-disable-next-line max-classes-per-file
export class Context {
    // eslint-disable-next-line @typescript-eslint/no-useless-constructor, @typescript-eslint/no-empty-function
    constructor() { }
}
export function parentPath(path) {
    return String(path.split("/").slice(0, -1).join("/")) || "/";
}
export class ContextRegistry {
    entries = new Map();
    cache = new Map();
    seen = new Set();
    constructor() {
        this.add("/", {});
    }
    add(path, context) {
        this.entries.set(path, context);
        this.cache.set(path, structuredClone(context));
    }
    find(path) {
        return this.entries.get(path) ?? this.find(parentPath(path));
    }
    // eslint-disable-next-line max-statements
    update(path, updatedContext) {
        if (updatedContext === undefined) {
            return;
        }
        if (!this.seen.has(path)) {
            this.seen.add(path);
            this.add(path, updatedContext);
            return;
        }
        const context = this.find(path);
        for (const property in updatedContext) {
            if (updatedContext[property] !== this.cache.get(path)?.[property]) {
                context[property] = updatedContext[property];
            }
        }
        // eslint-disable-next-line @typescript-eslint/no-unsafe-argument
        Object.setPrototypeOf(context, Object.getPrototypeOf(updatedContext));
        this.cache.set(path, structuredClone(updatedContext));
    }
}
